import Vue from 'vue'
import Vuex from 'vuex'
import VuexPersistence from 'vuex-persist'
import { getStoreBuilder } from 'vuex-typex'

import './module/user'
import { UserState } from './module/user'

import './module/userAnime'
import { UserAnimeState } from './module/userAnime'

Vue.use(Vuex)

export interface RootState {
	user: UserState
	userAnime: UserAnimeState
}

const vuexLocal = new VuexPersistence({
	storage: window.localStorage,
})

const store = getStoreBuilder<RootState>().vuexStore({
	plugins: [vuexLocal.plugin],
})

export default store
